`timescale 1ns / 1ps

//******************************************************************************
//* BCD kivon egy decimlis helyirtkhez.                                    *
//******************************************************************************
module bcd_sub_4bit(
   input  wire [3:0] a,          //Kisebbtend (0-9).
   input  wire [3:0] b,          //Kivonand (0-9).
   input  wire       cin,        //Bejv tvitel.
   output wire [3:0] diff,       //Klnbsg (a-b).
   output wire       cout        //Kimen tvitel.
);

//******************************************************************************
//* A kivons elvgzse. A kimen tvitel miatt egy bittel nagyobb kivont     *
//* kell hasznlni (az FPGA-ban a kivonnak nincs tvitel kimenete).           *
//******************************************************************************
wire [3:0] diff_ab;

assign {cout, diff_ab} = {1'b0, a} - {1'b0, b} - cin;


//******************************************************************************
//* A BCD korrekci elvgzse. Ha az eredeti klnbsg negatv, akkor 10       *
//* hozzadsval korriglunk, hogy az eredmny 0 s 9 kztti legyen.         *
//******************************************************************************
wire [3:0] correction = (cout) ? 4'd10 : 4'd0;

assign diff = diff_ab + correction;

endmodule
